* Create a cursor of products, countries sold to, and total quantity sold to
* that country. This is UNIONed with records of products that weren't sold and
* customers that haven't bought anything so we have a complete cross-tab.

close all
select PRODUCTS.ENG_NAME, ;
		CUSTOMER.COUNTRY, ;
		sum(ORDITEMS.QUANTITY) ;
	from CUSTOMER, ;
		ORDERS, ;
		ORDITEMS, ;
		PRODUCTS ;
	where CUSTOMER.CUST_ID = ORDERS.CUST_ID and ;
		ORDERS.ORDER_ID = ORDITEMS.ORDER_ID and ;
		ORDITEMS.PRODUCT_ID = PRODUCTS.PRODUCT_ID ;
	group by 1, 2 ;
	union select PRODUCTS.ENG_NAME, ;
		'', ;
		0 ;
	from PRODUCTS ;
	where PRODUCTS.PRODUCT_ID not in ;
		(select PRODUCT_ID from ORDITEMS) ;
	union select '', ;
		CUSTOMER.COUNTRY, ;
		0 ;
	from CUSTOMER ;
	where CUSTOMER.CUST_ID not in ;
		(select CUST_ID from ORDERS) ;
	into cursor XTABFIRST

* The cross-tab table might contain some duplicate product-country combinations
* because there might be some customers from a certain country who bought a
* product (so the first SELECT picked them up) but other customers from the
* same country who didn't buy anything (so the second SELECT picked them up).
* We'll use another SELECT to consolidate these.

select * ;
	from XTABFIRST ;
	into cursor XTAB ;
	group by 1, 2

* Get the Print Setup settings.

= sys(1037)

* Use XTABREP to do the job.

do XTABREP with 'Product', 'Product Sales by Country', 'preview'

* Clean up and exit.

close all
